# Request for Comments (RFC)

RFC stands for `Request for Comments`. It is a social device use to float and polish an idea prior to the inclusion into an existing or new spec/paper/research topic.

An RFC should not be used for bug reports or trivial discussions - the overhead of compiling an RFC does not justify it.

An RFC should not consist only of a problem statement (use a standard issue for that).

A RFC should consist of:

- Changelog
- Context on the relevant goals and the current state
- Proposed Solution
- Summary of pros and cons
- References

If recorded decisions turned out to be lacking, convene a discussion, record the new decisions here, and then modify the code to match.

**Note the context/background should be written in the present tense.**

Some RFC's will be presented at a Tendermint Dev Session. If you are an outside contributor and have submitted a RFC, you may be invited to present your RFC at one of these calls.

## Table of Contents

[001-block-retention](./001-block-retention.md)
